HDU 1501 Zipper

Problem Description

Given three strings, you are to determine whether the third string can be formed by combining the characters in the first two strings. The first two strings can be mixed arbitrarily, but each must stay in its original order.

For example, consider forming "tcraete" from "cat" and "tree":

String A: cat
String B: tree
String C: tcraete

As you can see, we can form the third string by alternating characters from the two strings. As a second example, consider forming "catrtee" from "cat" and "tree":

String A: cat
String B: tree
String C: catrtee

Finally, notice that it is impossible to form "cttaree" from "cat" and "tree".

Input

The first line of input contains a single positive integer from 1 through 1000. It represents the number of data sets to follow. The processing for each data set is identical. The data sets appear on the following lines, one data set per line.

For each data set, the line of input consists of three strings, separated by a single space. All strings are composed of upper and lower case letters only. The length of the third string is always the sum of the lengths of the first two strings. The first two strings will have lengths between 1 and 200 characters, inclusive.

Output

For each data set, print:

Data set n: yes

if the third string can be formed from the first two, or

Data set n: no

if it cannot. Of course n should be replaced by the data set number. See the sample output below for an example.

Sample Input

3
cat tree tcraete
cat tree catrtee
cat tree cttaree

Sample Output

Data set 1: yes
Data set 2: yes
Data set 3: no

Source

Pacific Northwest 2004

 1 #include<iostream>
 2 #include<cstring>
 3 using namespace std;
 4 char a[205],b[205],c[405];
 5 int l1,l2,l3;
 6 bool flag;
 7 int vis[205][205];
 8 void dfs(int x,int y,int z)
 9 {
10     if(flag)
11         return;
12     if(z==l3)
13     {
14         flag=true;
15         return;
16     }
17     if(vis[x][y]==1)
18         return;
19     vis[x][y]=1;
20     if(a[x]==c[z])
21         dfs(x+1,y,z+1);
22     if(b[y]==c[z])
23         dfs(x,y+1,z+1);
24 }
25 int main()
26 {
27     int T,t;
28     cin>>T;
29     for(t=1;t<=T;t++)
30     {
31         cin>>a>>b>>c;
32         l1=strlen(a);
33         l2=strlen(b);
34         l3=strlen(c);
35         flag=false;
36         memset(vis,0,sizeof(vis));//防止超时
37         if(l1+l2==l3)
38         dfs(0,0,0);
39         printf("Data set %d: ",t);
40         if(flag)printf("yes\n");
41         else printf("no\n");
42     }
43     return 0;
44 }


HDU 1501 Zipper

时间: 2024-10-11 14:23:02

HDU 1501 Zipper的相关文章

hdu 1501 Zipper (dfs+记忆化搜索)

Zipper Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6491    Accepted Submission(s): 2341 Problem Description Given three strings, you are to determine whether the third string can be formed

HDU 1501 Zipper(DP,DFS)

题意  判断能否由字符串a,b中的字符不改变各自的相对顺序组合得到字符串c 本题有两种解法  DP或者DFS 考虑DP  令d[i][j]表示能否有a的前i个字符和b的前j个字符组合得到c的前i+j个字符  值为0或者1  那么有d[i][j]=(d[i-1][j]&&a[i]==c[i+j])||(d[i][j-1]&&b[i]==c[i+j])   a,b的下标都是从1开始的  注意0的初始化 #include<cstdio> #include<cst

hdu 1501 Zipper dfs

题目链接: HDU - 1501 Given three strings, you are to determine whether the third string can be formed by combining the characters in the first two strings. The first two strings can be mixed arbitrarily, but each must stay in its original order.For examp

hdu 1501 Zipper 记忆化搜索

Zipper Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 7188    Accepted Submission(s): 2571 Problem Description Given three strings, you are to determine whether the third string can be formed

POJ 2192 &amp;&amp; HDU 1501 Zipper (记忆化搜索)

Zipper Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 16803   Accepted: 5994 Description Given three strings, you are to determine whether the third string can be formed by combining the characters in the first two strings. The first tw

hdu 1501 Zipper(DP)

题意: 给三个字符串str1.str2.str3 问str1和str2能否拼接成str3.(拼接的意思可以互相穿插) 能输出YES否则输出NO. 思路: 如果str3是由str1和str2拼接而成,str1的前i个字符和str2的前j个字符一定构成str3的前i+j个字符.(因为拼接必须保证字符的顺序不变) 所以,,,这算是个变形的最长公共子序列? DP方程:dp[i][j]:str3的前i+j个字符能否由str1的前i个字符和str2的前j个字符拼接而成.布尔型. 看代码,, 代码: char

【HDOJ】1501 Zipper

DFS.注意剪枝,0ms. 1 #include <stdio.h> 2 #include <string.h> 3 4 #define False 0 5 #define True 1 6 #define MAXN 201 7 8 char stra[MAXN], strb[MAXN], strc[MAXN<<1]; 9 int len1, len2, len3; 10 11 int dfs(int e1, int e2, int e3) { 12 int i, fl

HUD 1501 Zipper(记忆化 or DP)

Problem Description Given three strings, you are to determine whether the third string can be formed by combining the characters in the first two strings. The first two strings can be mixed arbitrarily, but each must stay in its original order. For e

HDOJ 题目1501 Zipper(DFS)

Zipper Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 7223    Accepted Submission(s): 2576 Problem Description Given three strings, you are to determine whether the third string can be formed